From 462b9b8ea902b3a14688a8ffe75caf97063ed169 Mon Sep 17 00:00:00 2001
From: Mirko Vukovic <mirko.vukovic@us.tel.com>
Date: Wed, 23 Feb 2011 17:24:30 -0500
Subject: [PATCH] Modifications to make fsbv compile on cygwin

---
 examples.lisp                  |   11 ++++++++---
 fsbv.asd                       |    2 +-
 init.lisp                      |    5 +++--
 libffi-unix.lisp               |    4 ++--
 4 files changed, 14 insertions(+), 8 deletions(-)
 mode change 100644 => 100755 .gitignore
 mode change 100644 => 100755 cbuiltin.lisp
 mode change 100644 => 100755 convert.lisp
 mode change 100644 => 100755 cstruct.lisp
 mode change 100644 => 100755 defs.lisp
 mode change 100644 => 100755 examples.lisp
 mode change 100644 => 100755 foreign-object-components.lisp
 mode change 100644 => 100755 fsbv.asd
 mode change 100644 => 100755 functions.lisp
 mode change 100644 => 100755 init.lisp
 mode change 100644 => 100755 libffi-unix.lisp
 mode change 100644 => 100755 pkgdcl.lisp
 mode change 100644 => 100755 readme.html

diff --git a/.gitignore b/.gitignore
old mode 100644
new mode 100755
diff --git a/cbuiltin.lisp b/cbuiltin.lisp
old mode 100644
new mode 100755
diff --git a/convert.lisp b/convert.lisp
old mode 100644
new mode 100755
diff --git a/cstruct.lisp b/cstruct.lisp
old mode 100644
new mode 100755
diff --git a/defs.lisp b/defs.lisp
old mode 100644
new mode 100755
diff --git a/examples.lisp b/examples.lisp
old mode 100644
new mode 100755
index f72ad2f..31935e3
--- a/examples.lisp
+++ b/examples.lisp
@@ -1,6 +1,6 @@
 ;; Examples of using FSBV
 ;; Liam Healy 2009-04-07 22:13:34EDT examples.lisp
-;; Time-stamp: <2009-05-02 21:18:21EDT examples.lisp>
+;; Time-stamp: <2011-02-23 15:46:08 examples.lisp>
 ;; $Id: $
 
 (in-package :fsbv)
@@ -16,8 +16,13 @@
 ;;; (complex-add-real #c(1.0d0 2.0d0) 3.0d0)
 
 ;;; Load the libraries
-(cffi:load-foreign-library #+unix "libgslcblas.so")
-(cffi:load-foreign-library #+unix "libgsl.so")
+(cffi:load-foreign-library #+(and unix (not cygwin)) "libgslcblas.so"
+			   #+(and unix cygwin) "/bin/cyggslcblas-0.dll")
+
+;; (cffi:load-foreign-library #+(and unix cygwin) "/lib/lapack/cygblas-0.dll")
+
+(cffi:load-foreign-library #+(and unix (not cygwin)) "libgsl.so"
+			   #+(and unix cygwin) "/bin/cyggsl-0.dll")
 
 ;;; Define the foreign struct; see /usr/include/gsl/gsl_complex.h
 (defcstruct (complex :constructor complex :deconstructor (realpart imagpart))
diff --git a/foreign-object-components.lisp b/foreign-object-components.lisp
old mode 100644
new mode 100755
diff --git a/fsbv.asd b/fsbv.asd
old mode 100644
new mode 100755
index f67bdf1..084320f
--- a/fsbv.asd
+++ b/fsbv.asd
@@ -1,6 +1,6 @@
 ;; ADSF file for fsbv
 ;; Liam Healy 2009-02-22 09:42:23EST fsbv.asd
-;; Time-stamp: <2010-11-30 12:31:28EST fsbv.asd>
+;; Time-stamp: <2011-02-20 09:50:35 fsbv.asd>
 ;; $Id: $
 
 (in-package :common-lisp-user)
diff --git a/functions.lisp b/functions.lisp
old mode 100644
new mode 100755
diff --git a/init.lisp b/init.lisp
old mode 100644
new mode 100755
index ba41f66..5a04a98
--- a/init.lisp
+++ b/init.lisp
@@ -1,11 +1,12 @@
 ;; Load foreign library
 ;; Liam Healy 2009-02-22 09:55:45EST pkgdcl.lisp
-;; Time-stamp: <2010-11-30 12:26:11EST init.lisp>
+;; Time-stamp: <2011-02-20 09:54:16 init.lisp>
 
 (in-package :common-lisp-user)
 
 (cffi:load-foreign-library
  #+darwin "libffi.dylib"
- #+(and (not darwin) unix) "libffi.so")
+ #+cygwin "/bin/cygffi-4.dll"
+ #+(and (not darwin) (not cygwin) unix) "libffi.so")
 
 (pushnew :fsbv *features*)
diff --git a/libffi-unix.lisp b/libffi-unix.lisp
old mode 100644
new mode 100755
index b958a3e..75a6fa3
--- a/libffi-unix.lisp
+++ b/libffi-unix.lisp
@@ -1,6 +1,6 @@
 ;; CFFI-Grovel definitions for unix systems.
 ;; Liam Healy 2009-02-22 09:24:33EST libffi-unix.lisp
-;; Time-stamp: <2009-08-23 09:51:01EDT libffi-unix.lisp>
+;; Time-stamp: <2011-02-23 15:25:38 libffi-unix.lisp>
 ;; $Id: $
 
 (in-package :fsbv)
@@ -26,7 +26,7 @@
 (cenum abi
  ((:default-abi "FFI_DEFAULT_ABI"))
  ((:sysv "FFI_SYSV"))
- ((:unix64 "FFI_UNIX64")))
+ #-cygwin((:unix64 "FFI_UNIX64")))
 
 (ctype ffi-abi "ffi_abi")
 
diff --git a/pkgdcl.lisp b/pkgdcl.lisp
old mode 100644
new mode 100755
diff --git a/readme.html b/readme.html
old mode 100644
new mode 100755
-- 
1.7.4