From ea67778cdb81efadbeba9611831ac3263491b576 Mon Sep 17 00:00:00 2001
From: Mirko Vukovic <mirko.vukovic@us.tel.com>
Date: Wed, 23 Feb 2011 17:21:57 -0500
Subject: [PATCH] Adapted test to clisp precision

---
 documentation/affi/tutorial.pdf              |  Bin 120699 -> 120699 bytes
 foreign-array/foreign-array.lisp             |    2 +-
 grid/tests/element-functions.lisp            |   39 +++++++++++++------------
 3 files changed, 21 insertions(+), 20 deletions(-)
 mode change 100644 => 100755 documentation/COPYING
 mode change 100644 => 100755 documentation/affi/Makefile
 mode change 100644 => 100755 documentation/affi/tutorial.pdf
 mode change 100644 => 100755 documentation/affi/tutorial.tex
 mode change 100644 => 100755 documentation/grid.texi
 mode change 100644 => 100755 documentation/grid/Array-Operations.html
 mode change 100644 => 100755 documentation/grid/Copying.html
 mode change 100644 => 100755 documentation/grid/Creating-a-grid.html
 mode change 100644 => 100755 documentation/grid/Efficiency.html
 mode change 100644 => 100755 documentation/grid/Grid-Operations.html
 mode change 100644 => 100755 documentation/grid/Installation.html
 mode change 100644 => 100755 documentation/grid/Introduction.html
 mode change 100644 => 100755 documentation/grid/Operations.html
 mode change 100644 => 100755 documentation/grid/Representation.html
 mode change 100644 => 100755 documentation/grid/Systems.html
 mode change 100644 => 100755 documentation/grid/c_002darray.html
 mode change 100644 => 100755 documentation/grid/grid.html
 mode change 100644 => 100755 documentation/grid/index.html
 mode change 100644 => 100755 documentation/overview.html
 mode change 100644 => 100755 foreign-array/complex-types.lisp
 mode change 100644 => 100755 foreign-array/element-types.lisp
 mode change 100644 => 100755 foreign-array/foreign-array-tests.asd
 mode change 100644 => 100755 foreign-array/foreign-array.asd
 mode change 100644 => 100755 foreign-array/foreign-array.lisp
 mode change 100644 => 100755 foreign-array/methods.lisp
 mode change 100644 => 100755 foreign-array/number-conversion.lisp
 mode change 100644 => 100755 foreign-array/subclass.lisp
 mode change 100644 => 100755 foreign-array/symbol-type.lisp
 mode change 100644 => 100755 foreign-array/tests/compose.lisp
 mode change 100644 => 100755 foreign-array/tests/fast-array-access.lisp
 mode change 100644 => 100755 foreign-array/tests/lisp-unit-extension.lisp
 mode change 100644 => 100755 foreign-array/tests/timing.lisp
 mode change 100644 => 100755 foreign-array/types.lisp
 mode change 100644 => 100755 foreign-array/vector-matrix.lisp
 mode change 100644 => 100755 grid/affi/affi.lisp
 mode change 100644 => 100755 grid/affi/package.lisp
 mode change 100644 => 100755 grid/affi/transformers.lisp
 mode change 100644 => 100755 grid/affi/utility.lisp
 mode change 100644 => 100755 grid/array.lisp
 mode change 100644 => 100755 grid/compose.lisp
 mode change 100644 => 100755 grid/copy.lisp
 mode change 100644 => 100755 grid/functions.lisp
 mode change 100644 => 100755 grid/grid-tests.asd
 mode change 100644 => 100755 grid/grid.asd
 mode change 100644 => 100755 grid/higher.lisp
 mode change 100644 => 100755 grid/iterate.lisp
 mode change 100644 => 100755 grid/map.lisp
 mode change 100644 => 100755 grid/multiarray.lisp
 mode change 100644 => 100755 grid/package.lisp
 mode change 100644 => 100755 grid/read-write/read.lisp
 mode change 100644 => 100755 grid/slice.lisp
 mode change 100644 => 100755 grid/specification.lisp
 mode change 100644 => 100755 grid/tests/affi-tests.lisp
 mode change 100644 => 100755 grid/tests/augment.lisp
 mode change 100644 => 100755 grid/tests/compose.lisp
 mode change 100644 => 100755 grid/tests/element-functions.lisp
 mode change 100644 => 100755 grid/tests/grids.lisp
 mode change 100644 => 100755 grid/tests/higher.lisp
 mode change 100644 => 100755 grid/tests/map.lisp
 mode change 100644 => 100755 grid/tests/slice.lisp
 mode change 100644 => 100755 grid/util.lisp
 mode change 100644 => 100755 todo.text

diff --git a/documentation/COPYING b/documentation/COPYING
old mode 100644
new mode 100755
diff --git a/documentation/affi/Makefile b/documentation/affi/Makefile
old mode 100644
new mode 100755
diff --git a/documentation/affi/tutorial.pdf b/documentation/affi/tutorial.pdf
old mode 100644
new mode 100755
diff --git a/documentation/affi/tutorial.tex b/documentation/affi/tutorial.tex
old mode 100644
new mode 100755
diff --git a/documentation/grid.texi b/documentation/grid.texi
old mode 100644
new mode 100755
diff --git a/documentation/grid/Array-Operations.html b/documentation/grid/Array-Operations.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Copying.html b/documentation/grid/Copying.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Creating-a-grid.html b/documentation/grid/Creating-a-grid.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Efficiency.html b/documentation/grid/Efficiency.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Grid-Operations.html b/documentation/grid/Grid-Operations.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Installation.html b/documentation/grid/Installation.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Introduction.html b/documentation/grid/Introduction.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Operations.html b/documentation/grid/Operations.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Representation.html b/documentation/grid/Representation.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/Systems.html b/documentation/grid/Systems.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/c_002darray.html b/documentation/grid/c_002darray.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/grid.html b/documentation/grid/grid.html
old mode 100644
new mode 100755
diff --git a/documentation/grid/index.html b/documentation/grid/index.html
old mode 100644
new mode 100755
diff --git a/documentation/overview.html b/documentation/overview.html
old mode 100644
new mode 100755
diff --git a/foreign-array/complex-types.lisp b/foreign-array/complex-types.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/element-types.lisp b/foreign-array/element-types.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/foreign-array-tests.asd b/foreign-array/foreign-array-tests.asd
old mode 100644
new mode 100755
diff --git a/foreign-array/foreign-array.asd b/foreign-array/foreign-array.asd
old mode 100644
new mode 100755
diff --git a/foreign-array/foreign-array.lisp b/foreign-array/foreign-array.lisp
old mode 100644
new mode 100755
index ad375ef..c0fd55b
--- a/foreign-array/foreign-array.lisp
+++ b/foreign-array/foreign-array.lisp
@@ -1,6 +1,6 @@
 ;; Foreign (C or C-compatible) arrays
 ;; Liam Healy 2008-12-28 10:44:22EST foreign-array.lisp
-;; Time-stamp: <2010-07-20 17:49:36EDT foreign-array.lisp>
+;; Time-stamp: <2011-02-12 17:05:06 foreign-array.lisp>
 ;;
 ;; Copyright 2008, 2009, 2010 Liam M. Healy
 ;; Distributed under the terms of the GNU General Public License
diff --git a/foreign-array/methods.lisp b/foreign-array/methods.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/number-conversion.lisp b/foreign-array/number-conversion.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/subclass.lisp b/foreign-array/subclass.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/symbol-type.lisp b/foreign-array/symbol-type.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/tests/compose.lisp b/foreign-array/tests/compose.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/tests/fast-array-access.lisp b/foreign-array/tests/fast-array-access.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/tests/lisp-unit-extension.lisp b/foreign-array/tests/lisp-unit-extension.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/tests/timing.lisp b/foreign-array/tests/timing.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/types.lisp b/foreign-array/types.lisp
old mode 100644
new mode 100755
diff --git a/foreign-array/vector-matrix.lisp b/foreign-array/vector-matrix.lisp
old mode 100644
new mode 100755
diff --git a/grid/affi/affi.lisp b/grid/affi/affi.lisp
old mode 100644
new mode 100755
diff --git a/grid/affi/package.lisp b/grid/affi/package.lisp
old mode 100644
new mode 100755
diff --git a/grid/affi/transformers.lisp b/grid/affi/transformers.lisp
old mode 100644
new mode 100755
diff --git a/grid/affi/utility.lisp b/grid/affi/utility.lisp
old mode 100644
new mode 100755
diff --git a/grid/array.lisp b/grid/array.lisp
old mode 100644
new mode 100755
diff --git a/grid/compose.lisp b/grid/compose.lisp
old mode 100644
new mode 100755
diff --git a/grid/copy.lisp b/grid/copy.lisp
old mode 100644
new mode 100755
diff --git a/grid/functions.lisp b/grid/functions.lisp
old mode 100644
new mode 100755
diff --git a/grid/grid-tests.asd b/grid/grid-tests.asd
old mode 100644
new mode 100755
diff --git a/grid/grid.asd b/grid/grid.asd
old mode 100644
new mode 100755
diff --git a/grid/higher.lisp b/grid/higher.lisp
old mode 100644
new mode 100755
diff --git a/grid/iterate.lisp b/grid/iterate.lisp
old mode 100644
new mode 100755
diff --git a/grid/map.lisp b/grid/map.lisp
old mode 100644
new mode 100755
diff --git a/grid/multiarray.lisp b/grid/multiarray.lisp
old mode 100644
new mode 100755
diff --git a/grid/package.lisp b/grid/package.lisp
old mode 100644
new mode 100755
diff --git a/grid/read-write/read.lisp b/grid/read-write/read.lisp
old mode 100644
new mode 100755
diff --git a/grid/slice.lisp b/grid/slice.lisp
old mode 100644
new mode 100755
diff --git a/grid/specification.lisp b/grid/specification.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/affi-tests.lisp b/grid/tests/affi-tests.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/augment.lisp b/grid/tests/augment.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/compose.lisp b/grid/tests/compose.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/element-functions.lisp b/grid/tests/element-functions.lisp
old mode 100644
new mode 100755
index abddbcd..75adac8
--- a/grid/tests/element-functions.lisp
+++ b/grid/tests/element-functions.lisp
@@ -1,25 +1,26 @@
 ;; Test functions of elements
 ;; Liam Healy 2010-06-20 10:54:42EDT element-functions.lisp
-;; Time-stamp: <2010-07-03 22:49:28EDT element-functions.lisp>
+;; Time-stamp: <2011-02-23 15:56:32 element-functions.lisp>
 
 (in-package :grid)
 
 (lisp-unit:define-test element-functions
-  (lisp-unit:assert-numerical-equal
-   '((0.0d0 1.0d0 1.4142135623730951d0 1.7320508075688772d0)
-     (3.1622776601683795d0 3.3166247903554d0 3.4641016151377544d0 3.605551275463989d0)
-     (4.47213595499958d0 4.58257569495584d0 4.69041575982343d0 4.795831523312719d0))
-   ;; Elementwise application of a function
-   (contents
-    (map-grid :source (test-grid-double-float 'array '(3 4))
-	      :element-function 'sqrt)))
-  (lisp-unit:assert-numerical-equal
-   '(0.0d0 1.0d0 1.4142135623730951d0 1.7320508075688772d0
-     3.1622776601683795d0 3.3166247903554d0 3.4641016151377544d0
-     3.605551275463989d0 4.47213595499958d0 4.58257569495584d0
-     4.69041575982343d0 4.795831523312719d0)  
-   ;; Elementwise application of a function, reshaping into a 1d array
-   (contents
-    (map-grid :source (test-grid-double-float 'array '(3 4))
-	      :element-function 'sqrt
-	      :destination-specification '((array 12) double-float)))))
+   (let ((lisp-unit:*epsilon* #+clisp 1e-5 #-clisp nil))
+     (lisp-unit:assert-numerical-equal
+      '((0.0d0 1.0d0 1.4142135623730951d0 1.7320508075688772d0)
+	(3.1622776601683795d0 3.3166247903554d0 3.4641016151377544d0 3.605551275463989d0)
+	(4.47213595499958d0 4.58257569495584d0 4.69041575982343d0 4.795831523312719d0))
+      ;; Elementwise application of a function
+      (contents
+       (map-grid :source (test-grid-double-float 'array '(3 4))
+		 :element-function 'sqrt)))
+     (lisp-unit:assert-numerical-equal
+      '(0.0d0 1.0d0 1.4142135623730951d0 1.7320508075688772d0
+	3.1622776601683795d0 3.3166247903554d0 3.4641016151377544d0
+	3.605551275463989d0 4.47213595499958d0 4.58257569495584d0
+	4.69041575982343d0 4.795831523312719d0)  
+      ;; Elementwise application of a function, reshaping into a 1d array
+      (contents
+       (map-grid :source (test-grid-double-float 'array '(3 4))
+		 :element-function 'sqrt
+		 :destination-specification '((array 12) double-float))))))
diff --git a/grid/tests/grids.lisp b/grid/tests/grids.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/higher.lisp b/grid/tests/higher.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/map.lisp b/grid/tests/map.lisp
old mode 100644
new mode 100755
diff --git a/grid/tests/slice.lisp b/grid/tests/slice.lisp
old mode 100644
new mode 100755
diff --git a/grid/util.lisp b/grid/util.lisp
old mode 100644
new mode 100755
diff --git a/todo.text b/todo.text
old mode 100644
new mode 100755
-- 
1.7.4